=== debian/changelog ===
boost1.62 (1.62.0+dfsg-10) unstable; urgency=medium

  * [e21ab62] Set gcc version 8 for the build.
  * [1886a38] Add dependency on g++-8.

 -- Anton Gladky <gladk@debian.org>  Fri, 14 Sep 2018 09:41:15 +0200

boost1.62 (1.62.0+dfsg-9) unstable; urgency=medium

  * [7809fdb] Drop dependency on libstdc++-4.8-dev. (Closes: #908732)
  * [c9ad4c1] Drop versioned dependency on g++-6. (Closes: #892390)

 -- Anton Gladky <gladk@debian.org>  Thu, 13 Sep 2018 22:40:44 +0200

boost1.62 (1.62.0+dfsg-8) unstable; urgency=medium

  * [85e2e8d] Add missing dependencies in python-autopkgtest
  * [d7ef962] Add missing deps (threads) in wave-autopkgtest
  * [1b25ec5] Add .gitlab-cy.yml to trigger autopkgtest in CI
  * [826e6fd] Add missing dependency in wave-test

 -- Anton Gladky <gladk@debian.org>  Sun, 15 Jul 2018 20:19:13 +0200

boost1.62 (1.62.0+dfsg-7) unstable; urgency=medium

  * [9b3650f] Add myself to uploaders
  * [2d088ce] Add initial autopkgtests

 -- Anton Gladky <gladk@debian.org>  Thu, 12 Jul 2018 19:14:00 +0200

boost1.62 (1.62.0+dfsg-6) unstable; urgency=medium

  * Fix building with Python 3.7 (closes: #902702).
  * Update Vcs-* fields after migration to git and to salsa.
  * Bump Standards-Version to 4.1.4.

 -- Giovanni Mascellani <gio@debian.org>  Sat, 30 Jun 2018 22:55:57 +0200

boost1.62 (1.62.0+dfsg-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * The rebuild against icu 60 changes some symbols as boost::regex
    embeds the icu version on them. Thus:
    - Build-depend on libicu-dev >= 60 to ensure we build with the new
      ABI.
    - Bump the shlibs version to ensure that rdeps that build against the
      new ABI get a minimum dependency on the shared lib.
    - Add breaks against packages built against the old ABI, so that those
      packages and libboost-regex are upgraded in lockstep.
    - All of the above closes: #898369.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Sat, 19 May 2018 16:35:58 +0200

boost1.62 (1.62.0+dfsg-5) unstable; urgency=medium

  * patches/flat-map-remove-partial-specializations.patch: New.  Upstream
    patch to remove now-unnecessary partial specializations.  Closes:
    #883987.

 -- Steve M. Robbins <smr@debian.org>  Sat, 06 Jan 2018 14:44:32 -0600

boost1.62 (1.62.0+dfsg-4) unstable; urgency=medium

  * New patch upstream-add-degree-reverse_graph.patch.

 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Nov 2016 12:46:50 -0600

boost1.62 (1.62.0+dfsg-3) unstable; urgency=high

  * Build Boost.Python 2 & 3 bindings in separate builddirs. Closes: #842927

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 07 Nov 2016 18:44:37 +0000

boost1.62 (1.62.0+dfsg-2) unstable; urgency=medium

  * Limit boost-fiber packages to architectures it is built on.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 20 Oct 2016 08:36:55 +0100

boost1.62 (1.62.0+dfsg-1) unstable; urgency=medium

  * New upstream 1.62.
  * Add packages for Boost.Fiber.
  * Drop package libboost1.62-dbg in favour of using automatic debug
    package generation.
  * Refresh patches.  Drop add-missing-list-include.patch -- applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Sun, 16 Oct 2016 01:55:19 -0500

boost1.61 (1.61.0+dfsg-3) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Actually bump standards version.

  [ Steve M. Robbins ]
  * Install /usr/bin/b2, the canonical name of bjam.  Closes: #831431.
  * libboost-iostreams1.61.0: remove Priority Important.  Closes: #829301.

 -- Steve M. Robbins <smr@debian.org>  Sat, 15 Oct 2016 10:59:14 -0500

boost1.61 (1.61.0+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Upload to unstable.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 03 Aug 2016 21:10:58 +0200

boost1.61 (1.61.0+dfsg-2) experimental; urgency=high

  * Use DEB_HOST_GNU_TYPE for the compiler, because DEB_HOST_MULTIARCH is
    a lie - i386 port doesn't really exist, nor provides/uses i386
    compiler. Fixes FTBFS on i386.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 03 Aug 2016 03:21:52 +0100

boost1.61 (1.61.0+dfsg-1) experimental; urgency=medium

  * New upstream release
  * Drop upstream cherrypicked patches, no longer needed
  * Update example files and sort them
  * Force use g++-6
  * Add python3:Depends for python packages (pacify dh_python3 warnings)
  * Drop python2.5 depends
  * Require icu 57 or better

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 01 Aug 2016 14:05:10 +0100

boost1.60 (1.60.0+dfsg-6) unstable; urgency=medium

  * patches/fix-ebo_functor_holder.patch: New. Compile fix for copy
    constructor (thanks, Graham Inggs).  Closes: #824021.

  * patches/add-missing-list-include.patch: New.  Add missing <list>
    include (thanks, Graham Inggs).  Closes: #824022.

 -- Steve M. Robbins <smr@debian.org>  Sun, 15 May 2016 23:38:50 -0500

boost1.60 (1.60.0+dfsg-5) unstable; urgency=medium

  [ Dimitri John Ledkov ]
  * Cherrypick upstream graph patch to fix ftbfs when adjacency_matrix.hpp
    template is used. Fixes FTBFS of sfcgal.

  [ Steve M. Robbins ]
  * patches/fix-auto-pointer-registration.patch: New.  Fixes auto-pointer
    registration in Boost.Python, affecting yade.  Closes: #823210.

 -- Steve M. Robbins <smr@debian.org>  Sat, 07 May 2016 22:23:17 -0500

boost1.60 (1.60.0+dfsg-4) unstable; urgency=medium

  * Fully enable context and coroutine on arm64, as it is available there.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 22 Apr 2016 14:52:41 +0100

boost1.60 (1.60.0+dfsg-3) unstable; urgency=medium

  * Drop all the without/just mpi build logic, Ubuntu no longer needs it,
    as Archive Reorg is complete and packages in main can now build-depend
    on packages in universe (e.g. mpi). Boost can now be in-sync between
    Debian and Ubuntu.
  * Drop context/coroutine from arm64, not build there.
  * Arch qualify all context/coroutine dependencies such that we don't
    declare dependencies on non-existant packages.


